bin巨的数(数位DP)

题目描述

作为ACM史上年度重量级人物,bin巨目前已经掌握了史上最NB的数,群巨快来仰慕!!我们定义这样一个数,它里面的每一个数字都是成双成对出现 的,but,如果这个数里面存在0那么这也是NB的数,比如11,122122,12035,当然,需要剔除那些首位是0的数。我们的目标就是计算一个区 间内bin巨有多少NB数!

输入

输入第一行包含一个整数T,表示接下来有T组数据。

下面T行,每行包含两个数l和r,表示这个区间。

数据范围:0<=l<=r<=10^18

输出

输出T行,每行一个数字表示这个区间内的NB数!

样例输入

3
1 5
11 13
10 23

样例输出

0
1
4

小新巨巨出的一道数位DP:用二进制表示0~9每个数字出现的次数的奇偶。

0:表示出现偶数次,1:表示出现奇数次。

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<string>
#include<iostream>
#include<queue>
#include<cmath>
#include<map>
#include<stack>
#include<bitset>
using namespace std;
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define CLEAR( a , x ) memset ( a , x , sizeof a )
typedef long long LL;
typedef pair<int,int>pil;
const int INF = 0x3f3f3f3f;
const int maxn=1e5+100;
LL l,r;
int t;
int num[30];
LL dp[20][1800][2];
int ok(int x)
{
    if(x&1) return 1;
    for(int i=1;i<=9;i++)
        if(x&(1<<i)) return 0;
    return  1;
}
LL dfs(int pos,int s,int first,int flag)
{
    if(pos==0)
        return first&&ok(s);
    if(!flag&&dp[pos][s][first]!=-1)
        return dp[pos][s][first];
    LL ans=0;
    int ed=flag?num[pos]:9;
    for(int i=0;i<=ed;i++)
    {
        int f=first;
        if(!first&&i)  f=1;
        if(f&&i==0) ans+=dfs(pos-1,s|1,f,flag&&i==ed);
        else if(!f&&!i) ans+=dfs(pos-1,s,f,flag&&i==ed);
        else ans+=dfs(pos-1,s^(1<<i),f,flag&&i==ed);
    }
    if(!flag) dp[pos][s][first]=ans;
    return ans;
}
LL solve(LL x)
{
    if(x==0)  return 1;
    int pos=0;
    while(x)
    {
        num[++pos]=x%10;
        x/=10;
    }
    return dfs(pos,0,0,1)+1;
}
int main()
{
    CLEAR(dp,-1);
    scanf("%d",&t);
    while(t--)
    {
        scanf("%lld%lld",&l,&r);
        LL ans=solve(r)-solve(l-1);
        printf("%lld\n",ans);
    }
    return 0;
}
时间: 2024-10-18 09:04:08

bin巨的数(数位DP)的相关文章

uestc250windy数数位dp

#include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #include <list> #include <

USETC 250 windy数 数位DP

注意处理数字只有一位的情况(其实不用怎么处理)= = 简单数位DP #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #

[数位dp] kuangbinoj 1012 bin巨的数

题意: 作为ACM史上年度重量级人物,bin巨目前已经掌握了史上最NB的数,群巨快来仰慕!!我们定义这样一个数,它里面的每一个数字都是成双成对出现 的,but,如果这个数里面存在0那么这也是NB的数,比如11,122122,12035,当然,需要剔除那些首位是0的数.我们的目标就是计算一个区 间内bin巨有多少NB数! 思路: 简单的数位dp,需要考虑每个数字出现的次数(0,1),是否有前导0,是否出现了0. 这里需要注意的就是0不是一个bin巨数. #include"cstdlib"

bzoj1026: [SCOI2009]windy数 数位dp

题目: http://www.lydsy.com/JudgeOnline/problem.php?id=1026 题意: Description windy定义了一种windy数.不含前导零且相邻两个数字之差至少为2的正整数被称为windy数. windy想知道, 在A和B之间,包括A和B,总共有多少个windy数? Input 包含两个整数,A B. Output 一个整数 思路: 数位dp,记忆化搜索. 1 #include <bits/stdc++.h> 2 3 using namesp

【BZOJ-1026】windy数 数位DP

1026: [SCOI2009]windy数 Time Limit: 1 Sec  Memory Limit: 162 MBSubmit: 5230  Solved: 2353[Submit][Status][Discuss] Description windy定义了一种windy数.不含前导零且相邻两个数字之差至少为2的正整数被称为windy数. windy想知道,在A和B之间,包括A和B,总共有多少个windy数? Input 包含两个整数,A B. Output 一个整数 Sample I

[BZOJ 1026][SCOI 2009]windy数(数位DP)

题目链接:http://www.lydsy.com:808/JudgeOnline/problem.php?id=1026 很基础的数位DP题,很早之前我就尝试做这题,不过当时我被这题吓死了,现在回过头做这题,感觉简单多了. 做这个题时我想到了POJ一道类似的组合数学的题,同样是按数位统计,有异曲同工之妙. 题目要求[a,b]区间上的windy数个数,我们可以转化成求[1,a]上的windy数个数-[1,b-1]上的windy数个数.题目转化成了求[1,x]上的windy数个数,我们就写个函数c

【BZOJ1662】[Usaco2006 Nov]Round Numbers 圆环数 数位DP

[BZOJ1662][Usaco2006 Nov]Round Numbers 圆环数 Description 正如你所知,奶牛们没有手指以至于不能玩"石头剪刀布"来任意地决定例如谁先挤奶的顺序.她们甚至也不能通过仍硬币的方式. 所以她们通过"round number"竞赛的方式.第一头牛选取一个整数,小于20亿.第二头牛也这样选取一个整数.如果这两个数都是 "round numbers",那么第一头牛获胜,否则第二头牛获胜. 如果一个正整数N的二

bzoj 1026 [SCOI2009]windy数 数位dp

1026: [SCOI2009]windy数 Time Limit: 20 Sec Memory Limit: 256 MB 题目连接 http://www.lydsy.com/JudgeOnline/problem.php?id=1026 Description windy定义了一种windy数.不含前导零且相邻两个数字之差至少为2的正整数被称为windy数. windy想知道,在A和B之间,包括A和B,总共有多少个windy数? Input 包含两个整数,A B. Output 一个整数.

CCF 201312-4 有趣的数 (数位DP, 状压DP, 组合数学+暴力枚举, 推公式, 矩阵快速幂)

问题描述 我们把一个数称为有趣的,当且仅当: 1. 它的数字只包含0, 1, 2, 3,且这四个数字都出现过至少一次. 2. 所有的0都出现在所有的1之前,而所有的2都出现在所有的3之前. 3. 最高位数字不为0. 因此,符合我们定义的最小的有趣的数是2013.除此以外,4位的有趣的数还有两个:2031和2301. 请计算恰好有n位的有趣的数的个数.由于答案可能非常大,只需要输出答案除以1000000007的余数. 输入格式 输入只有一行,包括恰好一个正整数n (4 ≤ n ≤ 1000). 输